USE COWS
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

ALTER TABLE dbo.LK_MPLS_EVENT_TYPE
ADD [EVENT_TYPE_ID] SMALLINT NULL
GO

ALTER TABLE [dbo].[LK_MPLS_EVENT_TYPE]  WITH NOCHECK ADD  CONSTRAINT [FK04_LK_MPLS_EVENT_TYPE] FOREIGN KEY([EVENT_TYPE_ID])
REFERENCES [dbo].[LK_EVENT_TYPE] ([EVENT_TYPE_ID])
GO

ALTER TABLE dbo.MPLS_EVENT NOCHECK CONSTRAINT ALL
GO

ALTER TABLE dbo.LK_MPLS_EVENT_TYPE   
DROP CONSTRAINT UX01_LK_MPLS_EVENT_TYPE;  
GO

UPDATE dbo.LK_MPLS_EVENT_TYPE SET [EVENT_TYPE_ID]=3
INSERT LK_MPLS_EVENT_TYPE(MPLS_EVENT_TYPE_ID,MPLS_EVENT_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID) VALUES('6','Scheduled Implementation','1','1','1',GETDATE(),GETDATE(),5)
ALTER TABLE dbo.MPLS_EVENT CHECK CONSTRAINT ALL
GO

ALTER TABLE dbo.LK_MPLS_EVENT_TYPE
ALTER COLUMN [EVENT_TYPE_ID] SMALLINT NOT NULL
GO

ALTER TABLE dbo.LK_MPLS_EVENT_TYPE
ADD CONSTRAINT UX01_LK_MPLS_EVENT_TYPE UNIQUE (MPLS_EVENT_TYPE_DES, EVENT_TYPE_ID);   
GO

-----------------
ALTER TABLE dbo.LK_MPLS_ACTY_TYPE
ADD [EVENT_TYPE_ID] SMALLINT NULL
GO

ALTER TABLE [dbo].[LK_MPLS_ACTY_TYPE]  WITH NOCHECK ADD  CONSTRAINT [FK04_LK_MPLS_ACTY_TYPE] FOREIGN KEY([EVENT_TYPE_ID])
REFERENCES [dbo].[LK_EVENT_TYPE] ([EVENT_TYPE_ID])
GO

ALTER TABLE dbo.MPLS_EVENT_ACTY_TYPE NOCHECK CONSTRAINT ALL
GO

ALTER TABLE dbo.[LK_MPLS_ACTY_TYPE]   
DROP CONSTRAINT UX01_LK_MPLS_ACTY_TYPE;  
GO

UPDATE dbo.[LK_MPLS_ACTY_TYPE] SET [EVENT_TYPE_ID]=3
INSERT LK_MPLS_ACTY_TYPE(MPLS_ACTY_TYPE_ID,MPLS_ACTY_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID)       VALUES('14','COS','1','1','1',GETDATE(),GETDATE(),5)
INSERT LK_MPLS_ACTY_TYPE(MPLS_ACTY_TYPE_ID,MPLS_ACTY_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID)       VALUES('15','Downgrade','1','1','1',GETDATE(),GETDATE(),5)
INSERT LK_MPLS_ACTY_TYPE(MPLS_ACTY_TYPE_ID,MPLS_ACTY_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID)       VALUES('16','Hot Cut','1','1','1',GETDATE(),GETDATE(),5)
INSERT LK_MPLS_ACTY_TYPE(MPLS_ACTY_TYPE_ID,MPLS_ACTY_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID)       VALUES('17','Migration','1','1','1',GETDATE(),GETDATE(),5)
INSERT LK_MPLS_ACTY_TYPE(MPLS_ACTY_TYPE_ID,MPLS_ACTY_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID)       VALUES('18','Multipath','1','1','1',GETDATE(),GETDATE(),5)
INSERT LK_MPLS_ACTY_TYPE(MPLS_ACTY_TYPE_ID,MPLS_ACTY_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID)       VALUES('19','Re-Home','1','1','1',GETDATE(),GETDATE(),5)
INSERT LK_MPLS_ACTY_TYPE(MPLS_ACTY_TYPE_ID,MPLS_ACTY_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID)       VALUES('20','Routing (BGP, EIGRP, OSPF)','1','1','1',GETDATE(),GETDATE(),5)
INSERT LK_MPLS_ACTY_TYPE(MPLS_ACTY_TYPE_ID,MPLS_ACTY_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID)       VALUES('21','Turn-up','1','1','1',GETDATE(),GETDATE(),5)
INSERT LK_MPLS_ACTY_TYPE(MPLS_ACTY_TYPE_ID,MPLS_ACTY_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID)       VALUES('22','Upgrade','1','1','1',GETDATE(),GETDATE(),5)

ALTER TABLE dbo.MPLS_EVENT_ACTY_TYPE CHECK CONSTRAINT ALL
GO

ALTER TABLE dbo.[LK_MPLS_ACTY_TYPE]
ALTER COLUMN [EVENT_TYPE_ID] SMALLINT NOT NULL
GO

ALTER TABLE dbo.[LK_MPLS_ACTY_TYPE]
ADD CONSTRAINT UX01_LK_MPLS_ACTY_TYPE UNIQUE (MPLS_ACTY_TYPE_DES, EVENT_TYPE_ID);   
GO

----------
ALTER TABLE dbo.LK_VPN_PLTFRM_TYPE
ADD [EVENT_TYPE_ID] SMALLINT NULL
GO

ALTER TABLE [dbo].LK_VPN_PLTFRM_TYPE  WITH NOCHECK ADD  CONSTRAINT [FK04_LK_VPN_PLTFRM_TYPE] FOREIGN KEY([EVENT_TYPE_ID])
REFERENCES [dbo].[LK_EVENT_TYPE] ([EVENT_TYPE_ID])
GO

ALTER TABLE dbo.MPLS_EVENT NOCHECK CONSTRAINT ALL
GO

ALTER TABLE dbo.LK_VPN_PLTFRM_TYPE   
DROP CONSTRAINT UX01_LK_VPN_PLTFRM_TYPE;  
GO

UPDATE dbo.LK_VPN_PLTFRM_TYPE SET [EVENT_TYPE_ID]=3
INSERT LK_VPN_PLTFRM_TYPE(VPN_PLTFRM_TYPE_ID,VPN_PLTFRM_TYPE_DES,REC_STUS_ID,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT,EVENT_TYPE_ID)       VALUES('4','Non-VAS','1','1','1',GETDATE(),GETDATE(),5)
ALTER TABLE dbo.MPLS_EVENT CHECK CONSTRAINT ALL
GO

ALTER TABLE dbo.LK_VPN_PLTFRM_TYPE
ALTER COLUMN [EVENT_TYPE_ID] SMALLINT NOT NULL
GO

ALTER TABLE dbo.LK_VPN_PLTFRM_TYPE
ADD CONSTRAINT UX01_LK_VPN_PLTFRM_TYPE UNIQUE (VPN_PLTFRM_TYPE_DES, EVENT_TYPE_ID);   
GO

-----------------
CREATE TABLE [dbo].[LK_MDS_NTWK_ACTY_TYPE](
	[NTWK_ACTY_TYPE_ID] [tinyint] NOT NULL,
	[NTWK_ACTY_TYPE_CD] CHAR(1) NOT NULL,
	[NTWK_ACTY_TYPE_DES] [varchar](25) NOT NULL,
	[REC_STUS_ID] [tinyint] NOT NULL,
	[MODFD_DT] [smalldatetime] NULL,
	[CREAT_DT] [smalldatetime] NOT NULL,
 CONSTRAINT [PK_LK_MDS_NTWK_ACTY_TYPE] PRIMARY KEY CLUSTERED 
(
	[NTWK_ACTY_TYPE_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY],
 CONSTRAINT [UX01_LK_MDS_NTWK_ACTY_TYPE] UNIQUE NONCLUSTERED 
(
	[NTWK_ACTY_TYPE_CD] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY],
CONSTRAINT [UX02_LK_MDS_NTWK_ACTY_TYPE] UNIQUE NONCLUSTERED 
(
	[NTWK_ACTY_TYPE_DES] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX01_LK_MDS_NTWK_ACTY_TYPE] ON [dbo].[LK_MDS_NTWK_ACTY_TYPE]
(
	[REC_STUS_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

ALTER TABLE [dbo].[LK_MDS_NTWK_ACTY_TYPE] ADD  CONSTRAINT [DF_LK_MDS_NTWK_ACTY_TYPE_1]  DEFAULT ((1)) FOR [REC_STUS_ID]
GO

ALTER TABLE [dbo].[LK_MDS_NTWK_ACTY_TYPE] ADD  CONSTRAINT [DF_LK_MDS_NTWK_ACTY_TYPE_getdate]  DEFAULT (getdate()) FOR [CREAT_DT]
GO

ALTER TABLE [dbo].[LK_MDS_NTWK_ACTY_TYPE]  ADD  CONSTRAINT [FK01_LK_MDS_NTWK_ACTY_TYPE] FOREIGN KEY([REC_STUS_ID])
REFERENCES [dbo].[LK_REC_STUS] ([REC_STUS_ID])
GO

-------------------------------------------------------

-- New activity type 
ALTER TABLE dbo.MDS_EVENT
ADD [NTWK_ACTY_TYPE_ID] TINYINT NULL
GO

UPDATE dbo.MDS_EVENT SET [NTWK_ACTY_TYPE_ID]=1

ALTER TABLE dbo.MDS_EVENT
ALTER COLUMN [NTWK_ACTY_TYPE_ID] TINYINT NOT NULL
GO

ALTER TABLE [dbo].MDS_EVENT  ADD  CONSTRAINT [FK14_MDS_EVENT] FOREIGN KEY([NTWK_ACTY_TYPE_ID])
REFERENCES [dbo].LK_MDS_NTWK_ACTY_TYPE ([NTWK_ACTY_TYPE_ID])
GO

ALTER TABLE dbo.MDS_EVENT
ADD [NTWK_EVENT_TYPE_ID] TINYINT NULL
GO

ALTER TABLE [dbo].MDS_EVENT  ADD  CONSTRAINT [FK15_MDS_EVENT] FOREIGN KEY([NTWK_EVENT_TYPE_ID])
REFERENCES [dbo].LK_MPLS_EVENT_TYPE ([MPLS_EVENT_TYPE_ID])
GO

ALTER TABLE [dbo].[MPLS_EVENT_ACTY_TYPE]  DROP CONSTRAINT [FK01_MPLS_EVENT_ACTY_TYPE]
GO

ALTER TABLE [dbo].[MPLS_EVENT_ACTY_TYPE]  ADD CONSTRAINT [FK01_MPLS_EVENT_ACTY_TYPE] FOREIGN KEY([EVENT_ID])
REFERENCES [dbo].[EVENT] ([EVENT_ID])
GO

ALTER TABLE dbo.MDS_EVENT
ADD [VPN_PLTFRM_TYPE_ID] TINYINT NULL
GO

ALTER TABLE [dbo].MDS_EVENT  ADD  CONSTRAINT [FK16_MDS_EVENT] FOREIGN KEY([VPN_PLTFRM_TYPE_ID])
REFERENCES [dbo].LK_VPN_PLTFRM_TYPE ([VPN_PLTFRM_TYPE_ID])
GO

ALTER TABLE dbo.MDS_EVENT
ADD [DD_APRVL_NBR] [varchar](200) NULL,
SALS_ENGR_PHN VARCHAR(100) NULL,
SALS_ENGR_EMAIL VARCHAR(250) NULL,
NTWK_CUST_NME VARCHAR(250) NULL,
NTWK_H6 CHAR(9) NULL,
NTWK_H1 CHAR(9) NULL
GO

ALTER TABLE dbo.MDS_EVENT
ALTER COLUMN [H1] [dbo].[H1]  NULL
GO

ALTER TABLE dbo.MDS_EVENT
ALTER COLUMN [CUST_SOW_LOC_TXT] NVARCHAR(2000) NULL
GO

ALTER TABLE dbo.MDS_EVENT
ALTER COLUMN [MDS_ACTY_TYPE_ID] [TINYINT]  NULL
GO

CREATE TABLE dbo.MDS_EVENT_NTWK_CUST
(
	[MDS_EVENT_NTWK_CUST_ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[EVENT_ID] [int] NOT NULL,
	[INSTL_SITE_POC_NME] [varchar](200) NOT NULL,
	[INSTL_SITE_POC_PHN] [varchar](500) NOT NULL,
	[INSTL_SITE_POC_EMAIL] [varchar](200) NOT NULL,
	[ROLE_NME] [varchar](200) NOT NULL,
	[CREAT_DT] [datetime] NOT NULL,
	[REC_STUS_ID] [tinyint] NOT NULL,
	[MODFD_DT] [datetime] NULL,
 CONSTRAINT [PK_MDS_EVENT_NTWK_CUST] PRIMARY KEY CLUSTERED 
(
	[MDS_EVENT_NTWK_CUST_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

SET ANSI_PADDING ON
GO

CREATE NONCLUSTERED INDEX [IX01_MDS_EVENT_NTWK_CUST] ON [dbo].[MDS_EVENT_NTWK_CUST]
(
	[EVENT_ID] ASC
)
INCLUDE ([ROLE_NME]) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

SET ANSI_PADDING ON
GO

ALTER TABLE [dbo].[MDS_EVENT_NTWK_CUST] ADD  CONSTRAINT [DF_MDS_EVENT_NTWK_CUST_getdate_1]  DEFAULT (getdate()) FOR [CREAT_DT]
GO

ALTER TABLE [dbo].[MDS_EVENT_NTWK_CUST] ADD  CONSTRAINT [DF_MDS_EVENT_NTWK_CUST_REC_STUS_ID_1]  DEFAULT ((1)) FOR [REC_STUS_ID]
GO

ALTER TABLE [dbo].[MDS_EVENT_NTWK_CUST]  ADD  CONSTRAINT [FK01_MDS_EVENT_NTWK_CUST] FOREIGN KEY([EVENT_ID])
REFERENCES [dbo].[EVENT] ([EVENT_ID])
GO


-----------------------
CREATE TABLE dbo.MDS_EVENT_NTWK_TRPT
(
	[MDS_EVENT_NTWK_TRPT_ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[EVENT_ID] [int] NOT NULL,
	[MDS_TRNSPRT_TYPE] [varchar](100) NOT NULL,
	[LEC_PRVDR_NME] [varchar](200) NULL,
	[LEC_CNTCT_INFO] [varchar](1000) NULL,
	[MACH5_ORDR_NBR] [varchar](50) NULL,
	[IP_NUA_ADR] [varchar](255) NULL,
	[MPLS_ACCS_BDWD] [varchar](50) NULL,
	[SCA_NBR] [varchar](100) NULL,
	[TAGGD_CD] BIT NULL,
	[VLAN_NBR] [varchar](50) NULL,
	[MULTI_VRF_REQ] [varchar](255) NULL,
	[IP_VER] [varchar](50) NULL,
	[LOC_CITY] [varchar](200) NOT NULL,
	[LOC_STT_PRVN] [varchar](200) NOT NULL,
	[LOC_CTRY] [varchar](200) NOT NULL,
	[ASSOC_H6] CHAR(9) NULL,
	[CREAT_DT] [datetime] NOT NULL,
	[REC_STUS_ID] [tinyint] NOT NULL,
	[MODFD_DT] [datetime] NULL,
 CONSTRAINT [PK_MDS_EVENT_NTWK_TRPT] PRIMARY KEY CLUSTERED 
(
	[MDS_EVENT_NTWK_TRPT_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

SET ANSI_PADDING ON
GO

CREATE NONCLUSTERED INDEX [IX01_MDS_EVENT_NTWK_TRPT] ON [dbo].[MDS_EVENT_NTWK_TRPT]
(
	[EVENT_ID] ASC
)
INCLUDE ([MACH5_ORDR_NBR],[IP_NUA_ADR]) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

SET ANSI_PADDING ON
GO

ALTER TABLE [dbo].[MDS_EVENT_NTWK_TRPT]  ADD  CONSTRAINT [FK01_MDS_EVENT_NTWK_TRPT] FOREIGN KEY([EVENT_ID])
REFERENCES [dbo].[EVENT] ([EVENT_ID])
GO

ALTER TABLE [dbo].[MDS_EVENT_NTWK_TRPT] ADD  CONSTRAINT [DF_MDS_EVENT_NTWK_TRPT_getdate_1]  DEFAULT (getdate()) FOR [CREAT_DT]
GO

ALTER TABLE [dbo].[MDS_EVENT_NTWK_TRPT] ADD  CONSTRAINT [DF_MDS_EVENT_NTWK_TRPT_REC_STUS_ID_1]  DEFAULT ((1)) FOR [REC_STUS_ID]
GO

CREATE TABLE [dbo].[QLFCTN_NTWK_ACTY_TYPE](
	[NTWK_ACTY_TYPE_ID] [tinyint] NOT NULL,
	[QLFCTN_ID] [int] NOT NULL,
	[CREAT_DT] [smalldatetime] NOT NULL,
 CONSTRAINT [PK_QLFCTN_NTWK_ACTY_TYPE] PRIMARY KEY CLUSTERED 
(
	[NTWK_ACTY_TYPE_ID] ASC,
	[QLFCTN_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[QLFCTN_NTWK_ACTY_TYPE] ADD  CONSTRAINT [DF_QLFCTN_NTWK_ACTY_TYPE_getdate]  DEFAULT (getdate()) FOR [CREAT_DT]
GO

ALTER TABLE [dbo].[QLFCTN_NTWK_ACTY_TYPE]  ADD  CONSTRAINT [FK01_QLFCTN_NTWK_ACTY_TYPE] FOREIGN KEY([QLFCTN_ID])
REFERENCES [dbo].[LK_QLFCTN] ([QLFCTN_ID])
GO

ALTER TABLE [dbo].[QLFCTN_NTWK_ACTY_TYPE]  ADD  CONSTRAINT [FK02_QLFCTN_NTWK_ACTY_TYPE] FOREIGN KEY([NTWK_ACTY_TYPE_ID])
REFERENCES [dbo].[LK_MDS_NTWK_ACTY_TYPE] ([NTWK_ACTY_TYPE_ID])
GO

---Default all existing QLFCTN_NTWK_ACTY_TYPE to MDS-Only
INSERT INTO [QLFCTN_NTWK_ACTY_TYPE] ([NTWK_ACTY_TYPE_ID], [QLFCTN_ID])
SELECT 1, lq.[QLFCTN_ID]
FROM dbo.LK_QLFCTN lq WITH (NOLOCK) INNER JOIN
dbo.QLFCTN_EVENT_TYPE qet WITH (NOLOCK) ON lq.QLFCTN_ID = qet.QLFCTN_ID
WHERE qet.EVENT_TYPE_ID = 5
AND lq.REC_STUS_ID=1


--ADD NTWK_ONLY_CD to dbo.LK_FAIL_REAS

ALTER TABLE dbo.LK_FAIL_REAS
ADD NTWK_ONLY_CD BIT NULL
GO


--use cows
--go

--select mea.event_id as 'Event ID', mp.DD_APRVL_NBR as 'Design Doc #', count(1) as cnt
--from dbo.MPLS_EVENT_ACCS_TAG mea with (nolock) inner join
--dbo.mpls_event mp with (nolock) on mp.event_id=mea.EVENT_ID
--where mea.REC_STUS_ID=1 and mp.DD_APRVL_NBR<>'na' and mp.DD_APRVL_NBR <>'n/a'
--group by mea.event_id, mp.DD_APRVL_NBR
--having count(1)>2
--order by mea.event_id desc